module AndOrSearch where

import Data.List (sortBy)

{-
 Module for Searching And/Or Graph
-}

data AndOrNode a b = And a 
                   | Or  b
                     deriving (Eq,Show)

data ThreeValue = True3 | False3 | Unknown3 


search root gen compare test check include pfacts = 
    searchStep root gen compare test check 0 include [] pfacts 

searchStep (node@(And a)) gen compare test check depth include traversed pfacts
    | test node              = (True3,    pfacts)
    | node `include` pfacts     = (True3,    pfacts)
--    | node `include` traversed  = (True3,    pfacts)
    | not $ check node depth = (Unknown3, pfacts)
    | otherwise = 
        let nodes = sortBy compare $ gen node
        in f nodes pfacts 
            where 
              f [] pfacts = (True3, node:pfacts)
              f (n:nodes) pfacts =
                  let (b,pfacts') =  searchStep n gen compare test check (depth+1) include (node:traversed) pfacts in
                  case b of
                    True3    -> f nodes pfacts'
                    False3   -> (False3, pfacts')
                    Unknown3 -> (True3 , pfacts')

searchStep (node@(Or a)) gen compare test check depth include traversed pfacts 
    | test node              = (True3,    pfacts)
    | node `include` pfacts     = (True3,    pfacts)
    | node `include` traversed  = (False3,   pfacts) 
    | not $ check node depth = (Unknown3, pfacts)
    | otherwise = 
        let nodes = sortBy compare $ gen node 
        in f nodes pfacts 
           where 
              f [] pfacts = (False3, pfacts)
              f (n:nodes) pfacts =
                  let (b,pfacts') =  searchStep n gen compare test check (depth+1) include (node:traversed) pfacts in
                  case b of
                    True3    -> (True3, pfacts')
                    False3   -> f nodes pfacts'
                    Unknown3 -> (True3 , pfacts')
