module Main where

import System.IO (hFlush, readFile, stdout)
import System.Environment (getArgs)

import ParseTree
import Lexer
import Parser
import AST

import Complement

-- parseProgram :: String -> Either String ([Rule String])
parseProgram s = do
  tokens <- scanTokens s
  prog   <- parseProg tokens
  return $ convertToAST prog 

{-
-- parseExpression :: String -> Either String (Exp String)
parseExpression s = do
  tokens <- scanTokens s 
  exp    <- parseExp tokens
  return $ convertExp exp
-}

analysisArgs args = f 20 "" args
    where f lim file args = 
              case args of
                ('-':'l':_):s:ss ->
                    f (read s) file ss
                s:ss ->
                    f lim s ss
                _ ->
                    (lim, file)

usage = 
    putStrLn "./generate_cmpl [-l limit] FileName"

main = do args <- getArgs
          (lim, filename) <- return $ analysisArgs args
          case filename of 
            []  -> usage
            _   ->               
                do putStrLn $ "Input: " ++ filename
                   cont <- readFile filename
                   case parseProgram $! cont of 
                     Left errMsg -> putStrLn errMsg
                     Right rules -> 
                         do -- print rules
--                           print (normalizeProgram (SOrg "main") rules)
--                           let substs = makeSubsts rules
                           putStrLn $ (reportAnalysis rules lim)
                           let rules' = complementation (SOrg "main") rules lim
                           let rets = head $ [ v | (ARule _ (STpl (SNrm (SOrg "main") v)) _ es _) <- rules' ]
--                           print rules'
                           print (prettyVariables (STpl (SNrm (SOrg "main") rets)) rules')
